/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// dllstd.cxx
// Standard-Modul fr eine DLL

#include "precomp.h"
#include "../kram/sos.h"

#if defined SYSTEM_WIN

namespace sos {

Bool      _dll       = true;
HINSTANCE _hinstance;

//------------------------------------------------------------------------------------Dll_start
#if defined __BORLANDC__

    extern HINSTANCE _hInstance;       // von Borland definiert

    struct Dll_start
    {
        Dll_start()
        {
            _hinstance = _hInstance;     // von Borland definiert
        }
    };

    static Dll_start dll_start;

#endif
//--------------------------------------------------------------------------------------DllMain
#if defined SYSTEM_MFC  && ( defined _AFXDLL || defined _USRDLL )

#include <afxwin.h>         // MFC core and standard components

struct Hostole_mfcapp : CWinApp
{
                               ~Hostole_mfcapp          ();
	virtual BOOL                InitInstance            ();

  //DECLARE_MESSAGE_MAP()
};


Hostole_mfcapp hostole_mfcapp;


BOOL Hostole_mfcapp::InitInstance()
{
    //? AfxEnableControlContainer();
    _hinstance = m_hInstance;
    return TRUE;  //oder FALSE?
}


Hostole_mfcapp::~Hostole_mfcapp()
{
}


#else

#include <windows.h>

extern "C"
BOOL WINAPI DllMain( HANDLE hInst, DWORD ul_reason_being_called, LPVOID )
{
    switch( ul_reason_being_called )
	{
		case DLL_PROCESS_ATTACH: _hinstance = (::HINSTANCE)hInst; break;
		case DLL_THREAD_ATTACH : break;
    	case DLL_PROCESS_DETACH: break;
    	case DLL_THREAD_DETACH : break;
                        default: break;
	}

    return TRUE;
}

#endif
//--------------------------------------------------------------------------------------LibMain
#ifdef SYSTEM_WIN16

extern "C"
int FAR PASCAL LibMain( HINSTANCE hInstance, WORD, WORD wHeapSize, LPSTR )
{
	if( wHeapSize >= 0 )  UnlockData( 0 );

	_hinstance = hInstance;

	return 1 ;
}

#endif
//------------------------------------------------------------------------------------------WEP
#if 0 //def SYSTEM_WIN16

int CALLBACK WEP( int /*exit_type*/ )
{
    OutputDebugString( "hostapi.dll beendet mit WEP()\n" );
    if( hostapi_count ) {
        char buffer [ 100 ];
        sprintf( buffer, "*** %d MAL sos_init() OHNE sos_exit() GERUFEN ***\n", (int)hostapi_count );
        OutputDebugString( buffer );
    }
    return 1;
}

#endif

} //namespace sos

#endif

