/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include <precomp.h>
#define MODULE_NAME "errors"
//                                                    (c) SOS GmbH Berlin
//                                                        Joacim Zschimmer

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <sos.h>
#include <anyfile.h>
#include <log.h>

int main (void)
{
Any_file                error_file;
FILE*                   in;
char                    text[ 300 ];

error_file.open( "errors.txt",
                 Abs_file_base::Open_mode( Abs_file_base::out | Abs_file_base::trunc | Abs_file_base::unsafe ),
                 File_spec( 512, Key_spec( 0, 32 ) ));   xc;

in = stdin;  //fopen ("errors.txt", "r");
if (in == NULL) {
    perror ("errors.txt lt sich nicht ffnen");
    exit (1);
}

loop {
    char* p = fgets (text, sizeof text, in);
    if( !p )  break;
    if (text [strlen (text) - 1] == '\n')
        text [strlen (text) - 1] = 0;
    error_file.insert( Const_area( text, strlen (text) ));  xc;
}

error_file.close();  xc;
return 0;

exception_handler:
   cerr << "Exception " << _XC.name() << " " << _XC.error_code() << endl;
   discard_exception();
   return 1;
} // main

