/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "precomp.h"
//#define MODULE_NAME "soslimtx"
//#define COPYRIGHT   " 1995 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"

//#pragma implementation

#include "sosstrng.h"         // Fr storable.h: Storable_as<Sos_string>
#include "sos.h"
#include "sosfield.h"
#include "soslimtx.h"

#if !defined SYSTEM_INCLUDE_TEMPLATES
#   include "soslimtx.tpl"
#endif

using namespace std;
namespace sos {

//-----------------------------------------------------------------------------String0_area::assign
// als inline ist length um 2 zu hoch ( Borland-C++ 4.02 )
/*
void String0_area::assign( const String0_area& str )
{
    assign( str.char_ptr(), str.length() );
}
*/
//-----------------------------------------------------------------------------String0_area::assign
/*
void String0_area::assign( const char* str, uint len )
{
    allocate_min( len );  xc;
    memcpy( ptr(), str, len + 1 );
    length( len );

  exceptions
}
*/

char& String0_area::chr( uint pos )
{
    if( pos >  size() )  { Too_long_error x ( "SOS-1150" ); x.insert( pos ); x.insert( size() ); throw_xc( x ); }
    if( pos == size() )  char_ptr()[ pos ] = '\0';
    return char_ptr()[ pos ];
}


} //namespace sos
