/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// soswnmsg.h                                1995 SOS GmbH Berlin

#ifndef __SOSWNMSG_H
#define __SOSWNMSG_H

struct SOS_CLASS Has_mswin_message_handler
{
/*  Registriert eine Fensterklasse und ffnet ein Fenster dieser Klasse einmal fr
    alle Has_mswin_message_handler.

    Has_mswin_message_handler::mswin_message_handler() wird fr Botschaften mit dem Code msg
    aufgerufen. msg mu eindeutig sein.
*/

    HWND                        hwnd                    () const;
    static const char*          mswin_window_class_name ();
    static const char*          mswin_window_name       ();

  protected:
                                Has_mswin_message_handler()             {}
                                Has_mswin_message_handler( uint msg );
    virtual                    ~Has_mswin_message_handler();

    void                        register_msg            ( uint msg );

    virtual long                mswin_message_handler   ( HWND, UINT, WPARAM, LPARAM, Bool* processed ) = 0;

    friend class                Mswin_msg_window_manager;
};

#endif
