/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// videocur.h

#ifndef __VIDEOCUR_H
#define __VIDEOCUR_H

#if !defined __VIDEO_H
#   include <video.h>
#endif


struct Video_curses                     // Abstrakt
{
                                Video_curses            ();
    virtual                    ~Video_curses            (); 

    virtual void                set_cursor              ( Video_pos );
    virtual void                write                   ( Video_pos, char, Video_attr );
  //virtual void                write                   ( Video_pos, char*, int len, Video_attr );
  //virtual void                fill                    ( Video_pos, char, int len, Video_attr );
  //virtual void                move                    ( int ziel, int quelle, int zeilenanz );
  //virtual void                scroll_up               ( int oben, int unten, int anzahl );
  //virtual void                scroll_down             ( int oben, int unten, int anzahl );
    virtual void                sync                    ();

  private:
    void*                      _curses_window_ptr;  
};

#endif
