/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: spooler_embedded_files.cxx 6067 2010-03-23 11:46:42Z ss $
// ACHTUNG: NICHT AENDERN! DIESE DATEI IST GENERIERT VON files_to_c++.pl



#include "../zschimmer/zschimmer.h"
#include "../zschimmer/embedded_files.h"

const char file_scheduler_xsd[] = 
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<!-- $Id: spooler_embedded_files.cxx 6067 2010-03-23 11:46:42Z ss $ -->\n"
    "\n"
    "<xsd:schema \n"
    "xmlns:xsd          = \"http://www.w3.org/2001/XMLSchema\" \n"
    "elementFormDefault = \"qualified\">\n"
    "\n"
    "<!-- <xsd:key> nicht verwenden, libxslt kann das nicht: \"Internal error: xmlSchemaAreValuesEqual, failed to compare the values.\" -->\n"
    "\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "$Id: spooler_embedded_files.cxx 6067 2010-03-23 11:46:42Z ss $\n"
    "Schema f\xc3" "\xbc" "r die Scheduler-Konfiguration,\n"
    "s.a. http://www.zschimmer.com/sos/scheduler/konfiguration.html\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "\n"
    "\n"
    "<xsd:element name=\"spooler\">\n"
    "<xsd:complexType>\n"
    "<xsd:choice>\n"
    "<xsd:element name=\"config\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"base\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"file\" type=\"File\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element ref=\"params\"           minOccurs=\"0\"/>\n"
    "<xsd:element ref=\"security\"         minOccurs=\"0\"/>\n"
    "<xsd:element ref=\"cluster\"          minOccurs=\"0\"/>\n"
    "<xsd:element ref=\"process_classes\"  minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"schedules\"       minOccurs=\"0\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"schedule\" type=\"run_time\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"locks\" minOccurs=\"0\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"lock\" type=\"lock\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "\n"
    "<!--xsd:key name=\"lock\">\n"
    "<xsd:selector xpath=\"lock\"/>\n"
    "<xsd:field xpath=\"@name\"/>\n"
    "</xsd:key-->\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:choice>\n"
    "<xsd:element ref=\"script\"       minOccurs=\"0\"/>\n"
    "<xsd:element name=\"scheduler_script\" type=\"scheduler_script\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:choice minOccurs=\"0\">\n"
    "<xsd:element ref=\"http_server\"/>\n"
    "<xsd:element ref=\"web_services\"/>   <!-- veraltet -->\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:choice>\n"
    "<xsd:element ref=\"holidays\"/>\n"
    "<xsd:element ref=\"holiday\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:element ref=\"jobs\"             minOccurs=\"0\"/>\n"
    "<xsd:element ref=\"job_chains\"       minOccurs=\"0\"/>\n"
    "<xsd:element ref=\"commands\"         minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"spooler_id\"            type=\"Name\"/>\n"
    "<xsd:attribute name=\"port\"                  type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"tcp_port\"              type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"udp_port\"              type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"ip_address\"            type=\"String\"/>\n"
    "<xsd:attribute name=\"param\"                 type=\"String\"/>\n"
    "<xsd:attribute name=\"log_dir\"               type=\"File\"/>\n"
    "<xsd:attribute name=\"priority_max\"          type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"include_path\"          type=\"File\"/>\n"
    "<xsd:attribute name=\"java_class_path\"       type=\"String\"/>\n"
    "<xsd:attribute name=\"java_options\"          type=\"String\"/>\n"
    "<xsd:attribute name=\"main_scheduler\"        type=\"String\"/>  <!-- veraltet -->\n"
    "<xsd:attribute name=\"mail_xslt_stylesheet\"  type=\"File\"/>\n"
    "<xsd:attribute name=\"supervisor\"            type=\"String\"/>\n"
    "<xsd:attribute name=\"configuration_directory\" type=\"File\"/>\n"
    "<xsd:attribute name=\"central_configuration_directory\" type=\"File\"/>\n"
    "\n"
    "<xsd:attribute name=\"configuration_add_event\"    type=\"Path\"/>\n"
    "<xsd:attribute name=\"configuration_modify_event\" type=\"Path\"/>\n"
    "<xsd:attribute name=\"configuration_delete_event\" type=\"Path\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element ref=\"commands\"/>\n"
    "\n"
    "<xsd:element name=\"command\" type=\"Commands\">\n"
    "<xsd:annotation><xsd:documentation>Deprecated. Use &lt;commands></xsd:documentation></xsd:annotation>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"answer\">\n"
    "<xsd:complexType/>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element ref=\"add_jobs\"/>\n"
    "<xsd:element ref=\"add_order\"/>\n"
    "<xsd:element name=\"check_folders\" type=\"check_folders\"/>\n"
    "<xsd:element ref=\"kill_task\"/>\n"
    "<xsd:element ref=\"modify_job\"/>\n"
    "<xsd:element ref=\"modify_order\"/>\n"
    "<xsd:element ref=\"modify_spooler\"/>\n"
    "<xsd:element ref=\"register_remote_scheduler\"/>\n"
    "<xsd:element ref=\"remove_job_chain\"/>\n"
    "<xsd:element ref=\"remove_order\"/>\n"
    "<xsd:element name=\"run_time\" type=\"run_time\"/>\n"
    "<xsd:element ref=\"show_calendar\"/>\n"
    "<xsd:element ref=\"show_history\"/>\n"
    "<xsd:element ref=\"show_job\"/>\n"
    "<xsd:element ref=\"show_jobs\"/>\n"
    "<xsd:element ref=\"show_job_chains\"/>\n"
    "<xsd:element ref=\"show_job_chain\"/>\n"
    "<xsd:element ref=\"show_order\"/>\n"
    "<xsd:element ref=\"s\"/>\n"
    "<xsd:element ref=\"show_schedulers\"/>\n"
    "<xsd:element ref=\"show_state\"/>\n"
    "<xsd:element ref=\"show_task\"/>\n"
    "<xsd:element ref=\"service_request\"/>\n"
    "<xsd:element ref=\"start_job\"/>\n"
    "<!--xsd:element ref=\"signal_object\"/-->\n"
    "<xsd:element ref=\"terminate\"/>\n"
    "\n"
    "\n"
    "<!-- Asynchron ausgef\xc3" "\xbc" "hrte Kommandos -->\n"
    "<xsd:element ref=\"get_events\"/>\n"
    "</xsd:choice>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"cluster_member_command\">\n"
    "<xsd:complexType>\n"
    "<xsd:choice>\n"
    "<xsd:element name=\"terminate\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"timeout\" type=\"xsd:integer\"/>\n"
    "<xsd:attribute name=\"restart\" type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:choice>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"commands\" type=\"Commands\"/>\n"
    "\n"
    "<xsd:complexType name=\"Commands\">\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element ref=\"add_jobs\"/>\n"
    "<xsd:element ref=\"add_order\"/>\n"
    "<xsd:element name=\"check_folders\"               type=\"check_folders\"/>\n"
    "<xsd:element ref=\"kill_task\"/>\n"
    "<xsd:element ref=\"licence.use\"/>\n"
    "<xsd:element name=\"lock\"                        type=\"lock\"/>\n"
    "<xsd:element name=\"lock.remove\"                 type=\"lock.remove\"/>\n"
    "<xsd:element ref=\"modify_job\"/>\n"
    "<xsd:element ref=\"modify_hot_folder\"/>\n"
    "<xsd:element ref=\"modify_order\"/>\n"
    "<xsd:element ref=\"modify_spooler\"/>\n"
    "<xsd:element ref=\"job_chain.modify\"/>\n"
    "<xsd:element ref=\"job_chain_node.modify\"/>\n"
    "<xsd:element name=\"order\"                       type=\"order\"/>                  <!-- Nicht f\xc3" "\xbc" "r den Scheduler, sondern f\xc3" "\xbc" "r M\xc3" "\xbc" "r\xc3" "\xbc" "vet \xc3" "\x96" "ks\xc3" "\xbc" "zs Konfigurations-Editor. 2007-10-04 -->\n"
    "<xsd:element name=\"process_class\"               type=\"process_class\"/>\n"
    "<xsd:element name=\"process_class.remove\"        type=\"process_class.remove\"/>\n"
    "<xsd:element ref=\"register_remote_scheduler\"/>\n"
    "<xsd:element ref=\"remove_job_chain\"/>\n"
    "<xsd:element ref=\"remove_order\"/>\n"
    "<xsd:element name=\"run_time\"                    type=\"run_time\"/>\n"
    "<xsd:element ref=\"scheduler_log.log_categories.reset\"/>\n"
    "<xsd:element ref=\"scheduler_log.log_categories.set\"/>\n"
    "<xsd:element ref=\"scheduler_log.log_categories.show\"/>\n"
    "<xsd:element ref=\"show_calendar\"/>\n"
    "<xsd:element ref=\"show_history\"/>\n"
    "<xsd:element ref=\"show_job\"/>\n"
    "<xsd:element ref=\"show_jobs\"/>\n"
    "<xsd:element ref=\"show_job_chains\"/>\n"
    "<xsd:element ref=\"show_job_chain\"/>\n"
    "<xsd:element ref=\"show_order\"/>\n"
    "<xsd:element ref=\"s\"/>\n"
    "<xsd:element ref=\"show_schedulers\"/>\n"
    "<xsd:element ref=\"show_state\"/>\n"
    "<xsd:element ref=\"show_task\"/>\n"
    "<xsd:element ref=\"service_request\"/>\n"
    "<xsd:element ref=\"start_job\"/>\n"
    "<xsd:element ref=\"remote_scheduler.start_remote_task\"/>\n"
    "<xsd:element ref=\"remote_scheduler.remote_task.close\"/>\n"
    "<!--xsd:element ref=\"signal_object\"/-->\n"
    "<xsd:element ref=\"terminate\"/>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:attribute name=\"on_exit_code\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>\n"
    "Only valid in element job!\n"
    "examples: on_exit_code=\"success\" on_exit_code=\"error\" on_exit_code=\"1 2 3\"\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"success\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>This is exit code 0</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:enumeration>\n"
    "<xsd:enumeration value=\"error\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>This is all other exit codes but 0</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:enumeration>\n"
    "<xsd:enumeration value=\"signal\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>exit codes less than 0 (a signal under Unix)</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:enumeration>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:list>  \n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:integer\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Unix_signal_name\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:list>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:element name=\"add_jobs\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"job\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"add_order\" type=\"order\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"check_folders\" type=\"check_folders\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"holiday\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"date\" type=\"String\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"holidays\">\n"
    "<xsd:complexType>\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element name=\"weekdays\" minOccurs=\"0\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"day\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"day\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:list itemType=\"Weekday\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element ref=\"holiday\"/>\n"
    "<xsd:element ref=\"include\"/>\n"
    "</xsd:choice>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"include\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"file\"          type=\"File\"/>\n"
    "<xsd:attribute name=\"live_file\"     type=\"File\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"job\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"settings\" type=\"Job.Settings\" minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"description\" minOccurs=\"0\">\n"
    "<xsd:complexType mixed=\"true\">\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element ref=\"include\"/>\n"
    "</xsd:choice>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"lock.use\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"lock\"                  type=\"String\"       use=\"required\"/>\n"
    "<xsd:attribute name=\"exclusive\"             type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element ref=\"params\" minOccurs=\"0\"/>\n"
    "<xsd:element name=\"environment\" type=\"environment\" minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:choice minOccurs=\"0\">\n"
    "<xsd:element ref=\"script\"/>\n"
    "\n"
    "<xsd:element name=\"process\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"environment\" type=\"environment\" minOccurs=\"0\"/>  <!-- Veraltet -->\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"file\"              type=\"File\"        use=\"required\"/>\n"
    "<xsd:attribute name=\"param\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"log_file\"          type=\"File\"/>\n"
    "<xsd:attribute name=\"ignore_error\"      type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"ignore_signal\"     type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:element name=\"monitor\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"script\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"name\"                      type=\"Name\"/>\n"
    "<xsd:attribute name=\"ordering\"                  type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"start_when_directory_changed\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"directory\"     type=\"File\"                 use=\"required\"/>\n"
    "<xsd:attribute name=\"regex\"         type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"delay_after_error\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"error_count\"   type=\"xsd:positiveInteger\"  use=\"required\"/>\n"
    "<xsd:attribute name=\"delay\"         use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\"/>\n"
    "<!-- Das l\xc3" "\xa4" "sst libxslt abst\xc3" "\xbc" "rzen: \n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Duration\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"stop\"/>\n"
    "<xsd:enumeration value=\"stop\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union-->\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"delay_order_after_setback\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"setback_count\" type=\"xsd:positiveInteger\"  use=\"required\"/>\n"
    "<xsd:attribute name=\"delay\"         type=\"Duration\"/>\n"
    "<xsd:attribute name=\"is_maximum\"    type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"run_time\" type=\"run_time\" minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"commands\" type=\"Commands\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"name\"                  type=\"Name\"/>\n"
    "<xsd:attribute name=\"visible\"               type=\"Yes_no_never\"/>\n"
    "<xsd:attribute name=\"priority\"              type=\"Process_priority\"/>\n"
    "<xsd:attribute name=\"temporary\"             type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"spooler_id\"            type=\"Name\"/>\n"
    "<xsd:attribute name=\"title\"                 type=\"String\"/>\n"
    "<xsd:attribute name=\"log_append\"            type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"order\"                 type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"separate_process\"      type=\"Yes_no\"/>                     <!-- Veraltet, wird ignoriert -->\n"
    "<xsd:attribute name=\"tasks\"                 type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"min_tasks\"             type=\"xsd:positiveInteger\"/>\n"
    "<xsd:attribute name=\"timeout\"               type=\"Duration\"/>                   <!-- F\xc3" "\xbc" "r ap, 1.4.06 timeout=\"0\" soll erlaubt sein (kein Aprilscherz) -->\n"
    "<xsd:attribute name=\"idle_timeout\"          type=\"Duration_or_never\"/>\n"
    "<xsd:attribute name=\"force_idle_timeout\"    type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"process_class\"         type=\"Path\"/>\n"
    "<xsd:attribute name=\"mail_xslt_stylesheet\"  type=\"File\"/>\n"
    "<xsd:attribute name=\"java_options\"          type=\"String\"/>\n"
    "<xsd:attribute name=\"stop_on_error\"         type=\"Yes_no\"/>\n"
    "\n"
    "<xsd:attribute name=\"ignore_signals\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"all\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:list itemType=\"Unix_signal\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "<xsd:attribute name=\"replace\"               type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"warn_if_longer_than\"   type=\"Duration_or_percentage\"/>\n"
    "<xsd:attribute name=\"warn_if_shorter_than\"  type=\"Duration_or_percentage\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "<!--libxslt xsd:key name=\"delay_after_error\">\n"
    "<xsd:selector xpath=\"delay_after_error\"/>\n"
    "<xsd:field xpath=\"@error_count\"/>\n"
    "</xsd:key-->\n"
    "\n"
    "<!--libxslt xsd:key name=\"delay_order_after_setback\">\n"
    "<xsd:selector xpath=\"delay_order_after_setback\"/>\n"
    "<xsd:field xpath=\"@setback_count\"/>\n"
    "</xsd:key-->\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"Job.Settings\">\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"mail_on_error\"               type=\"Yes_no\"       minOccurs=\"0\"/>\n"
    "<xsd:element name=\"mail_on_warning\"             type=\"Yes_no\"       minOccurs=\"0\"/>\n"
    "<xsd:element name=\"mail_on_success\"             type=\"Yes_no\"       minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"mail_on_process\" minOccurs=\"0\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union memberTypes=\"Yes_no xsd:positiveInteger\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"mail_on_delay_after_error\" minOccurs=\"0\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"all\"/>\n"
    "<xsd:enumeration value=\"first_only\"/>\n"
    "<xsd:enumeration value=\"last_only\"/>\n"
    "<xsd:enumeration value=\"first_and_last_only\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"log_mail_to\"                 type=\"Non_empty_string\"   minOccurs=\"0\"/>\n"
    "<xsd:element name=\"log_mail_cc\"                 type=\"Non_empty_string\"   minOccurs=\"0\"/>\n"
    "<xsd:element name=\"log_mail_bcc\"                type=\"Non_empty_string\"   minOccurs=\"0\"/>\n"
    "<xsd:element name=\"log_level\"                   type=\"Log_level\"          minOccurs=\"0\"/>\n"
    "<xsd:element name=\"history\"                     type=\"Yes_no\"             minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"history_on_process\" minOccurs=\"0\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union memberTypes=\"Yes_no xsd:nonNegativeInteger\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"history_with_log\" minOccurs=\"0\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"yes\"/>\n"
    "<xsd:enumeration value=\"no\"/>\n"
    "<xsd:enumeration value=\"gzip\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:element name=\"job_chain\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"note\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "\n"
    "<xsd:choice>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"job_chain_node.job_chain\" type=\"job_chain_node.job_chain\"/>\n"
    "\n"
    "<xsd:choice maxOccurs=\"unbounded\">\n"
    "<xsd:element name=\"job_chain_node.job_chain\" type=\"job_chain_node.job_chain\"/>\n"
    "<xsd:element name=\"job_chain_node.end\"       type=\"job_chain_node.end\"/>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"file_order_source\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"directory\"         type=\"String\" use=\"required\"/>\n"
    "<xsd:attribute name=\"regex\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"delay_after_error\" type=\"xsd:positiveInteger\"/>\n"
    "\n"
    "<xsd:attribute name=\"repeat\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"no\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:positiveInteger\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "<xsd:attribute name=\"max\"               type=\"xsd:positiveInteger\"/>\n"
    "<xsd:attribute name=\"next_state\"        type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:choice maxOccurs=\"unbounded\">\n"
    "<xsd:element name=\"job_chain_node\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"state\"         type=\"String\" use=\"required\"/>\n"
    "<xsd:attribute name=\"job\"           type=\"Path\"/>\n"
    "<xsd:attribute name=\"next_state\"    type=\"String\"/>\n"
    "<xsd:attribute name=\"error_state\"   type=\"String\"/>\n"
    "<xsd:attribute name=\"on_error\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"setback\"/>\n"
    "<xsd:enumeration value=\"suspend\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "<xsd:attribute name=\"suspend\"       type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"delay\"         type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"file_order_sink\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"state\"         type=\"String\" use=\"required\"/>\n"
    "<xsd:attribute name=\"remove\"        type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"move_to\"       type=\"File\"/>\n"
    "<xsd:attribute name=\"delay\"         type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"job_chain_node.end\" type=\"job_chain_node.end\"/>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"name\"               type=\"Name\"/>\n"
    "<xsd:attribute name=\"replace\"            type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"visible\"            type=\"Yes_no_never\"/>\n"
    "<xsd:attribute name=\"orders_recoverable\" type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"distributed\"        type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"title\"              type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "<!--libxslt xsd:key name=\"job_chain_node\">\n"
    "<xsd:selector xpath=\"job_chain_node\"/>\n"
    "<xsd:field xpath=\"@state\"/>\n"
    "</xsd:key-->\n"
    "\n"
    "<!--xsd:keyref name=\"job_chain_node.next_state\" refer=\"job_chain_node\">\n"
    "<xsd:selector xpath=\"job_chain_node\"/>\n"
    "<xsd:field xpath=\"@next_state\"/>\n"
    "</xsd:keyref-->\n"
    "\n"
    "<!--xsd:keyref name=\"job_chain_node.error_state\" refer=\"job_chain_node\">\n"
    "<xsd:selector xpath=\"job_chain_node\"/>\n"
    "<xsd:field xpath=\"@error_state\"/>\n"
    "</xsd:keyref-->\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"job_chain_node.job_chain\">\n"
    "<xsd:attribute name=\"state\"         type=\"String\" use=\"required\"/>\n"
    "<xsd:attribute name=\"job_chain\"     type=\"Path\"/>\n"
    "<xsd:attribute name=\"next_state\"    type=\"String\"/>\n"
    "<xsd:attribute name=\"error_state\"   type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"job_chain_node.end\">\n"
    "<xsd:attribute name=\"state\"         type=\"String\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:element name=\"job_chains\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"job_chain\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"jobs\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"job\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "</xsd:complexType>\n"
    "\n"
    "<!--libxslt xsd:key name=\"job\">\n"
    "<xsd:selector xpath=\"job\"/>\n"
    "<xsd:field xpath=\"@name\"/>\n"
    "</xsd:key-->\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"kill_task\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job\"           type=\"Path\"         use=\"required\"/>\n"
    "<xsd:attribute name=\"id\"            type=\"Task_id\"      use=\"required\"/>\n"
    "<xsd:attribute name=\"immediately\"   type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"licence.use\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"key\"           type=\"String\"       use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"modify_job\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"run_time\" type=\"run_time\" minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"job\" type=\"Path\" use=\"required\"/>\n"
    "\n"
    "<xsd:attribute name=\"cmd\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"stop\"/>\n"
    "<xsd:enumeration value=\"unstop\"/>\n"
    "<xsd:enumeration value=\"start\"/>\n"
    "<xsd:enumeration value=\"wake\"/>\n"
    "<xsd:enumeration value=\"end\"/>\n"
    "<xsd:enumeration value=\"suspend\"/>\n"
    "<xsd:enumeration value=\"continue\"/>\n"
    "<xsd:enumeration value=\"reread\"/>\n"
    "<xsd:enumeration value=\"remove\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"modify_hot_folder\" type=\"modify_hot_folder\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"job_chain.modify\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job_chain\" type=\"Path\"         use=\"required\"/>\n"
    "\n"
    "<xsd:attribute name=\"state\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:enumeration value=\"running\"/>\n"
    "<xsd:enumeration value=\"stopped\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:element name=\"job_chain_node.modify\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job_chain\" type=\"Path\"         use=\"required\"/>\n"
    "<xsd:attribute name=\"state\"     type=\"String\"       use=\"required\"/>\n"
    "<xsd:attribute name=\"action\"    type=\"Job_chain_node.Action\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"lock\" type=\"lock\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"lock.remove\" type=\"lock.remove\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"modify_order\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"params\"                          minOccurs=\"0\"/>\n"
    "<xsd:element name=\"xml_payload\" type=\"Xml_payload\" minOccurs=\"0\"/>\n"
    "<xsd:element name=\"run_time\"    type=\"run_time\"    minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"job_chain\" type=\"Path\"         use=\"required\"/>\n"
    "<xsd:attribute name=\"order\"     type=\"Order_id\"     use=\"required\"/>\n"
    "<xsd:attribute name=\"priority\"  type=\"xsd:integer\"/>\n"
    "<xsd:attribute name=\"title\"     type=\"String\"/>\n"
    "<xsd:attribute name=\"state\"     type=\"String\"/>\n"
    "<xsd:attribute name=\"setback\"   type=\"No\"/>\n"
    "<xsd:attribute name=\"suspended\" type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"at\"        type=\"Date_time_with_now\"/>\n"
    "<xsd:attribute name=\"end_state\" type=\"String\"/>\n"
    "\n"
    "<xsd:attribute name=\"action\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"reset\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"modify_spooler\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"cmd\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"pause\"/>\n"
    "<xsd:enumeration value=\"continue\"/>\n"
    "<xsd:enumeration value=\"stop\"/>\n"
    "<xsd:enumeration value=\"reload\"/>\n"
    "<xsd:enumeration value=\"terminate\"/>\n"
    "<xsd:enumeration value=\"terminate_and_restart\"/>\n"
    "<xsd:enumeration value=\"let_run_terminate_and_restart\"/>\n"
    "<xsd:enumeration value=\"abort_immediately\"/>\n"
    "<xsd:enumeration value=\"abort_immediately_and_restart\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "<xsd:attribute name=\"timeout\" type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "\n"
    "\n"
    "<xsd:element name=\"note\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>additional note in HTML</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:complexType mixed=\"true\">\n"
    "<xsd:complexContent mixed=\"true\">\n"
    "<xsd:restriction base=\"xsd:anyType\">\n"
    "<xsd:sequence>\n"
    "<xsd:any namespace=\"http://www.w3.org/1999/xhtml\" processContents=\"lax\"/>\n"
    "</xsd:sequence>\n"
    "<xsd:attribute name=\"language\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:string\">\n"
    "<xsd:length value=\"2\"/>\n"
    "<xsd:enumeration value=\"de\"/>\n"
    "<xsd:enumeration value=\"en\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:restriction>\n"
    "</xsd:complexContent>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"order\" type=\"order\"/>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"order\">\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"params\" minOccurs=\"0\"/>\n"
    "<xsd:element name=\"run_time\" type=\"run_time\" minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"payload\" minOccurs=\"0\">\n"
    "<!--xsd:element ref=\"params\" minOccurs=\"0\"/-->\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:any processContents=\"skip\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"xml_payload\" type=\"Xml_payload\" minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"job_chain\"         type=\"Path\"/>\n"
    "<xsd:attribute name=\"id\"                type=\"Order_id\"/>\n"
    "<xsd:attribute name=\"priority\"          type=\"xsd:integer\"/>\n"
    "<xsd:attribute name=\"title\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"state\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"end_state\"         type=\"String\"/>\n"
    "<xsd:attribute name=\"web_service\"       type=\"Name\"/>\n"
    "<xsd:attribute name=\"replace\"           type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"at\"                type=\"Date_time_with_now\"/>\n"
    "<xsd:attribute name=\"suspended\"         type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<!--xsd:complexType name=\"order\">\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"params\"   minOccurs=\"0\"/>\n"
    "<xsd:element ref=\"run_time\" minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"payload\" minOccurs=\"0\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:any processContents=\"skip\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"xml_payload\" type=\"Xml_payload\" minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"priority\"          type=\"xsd:integer\"/>\n"
    "<xsd:attribute name=\"title\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"state\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"at\"                type=\"Date_time_with_now\"/>\n"
    "<xsd:attribute name=\"suspended\"         type=\"Yes_no\"/>\n"
    "</xsd:complexType-->\n"
    "\n"
    "\n"
    "<xsd:element name=\"param\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"name\"  type=\"String\" use=\"required\"/>\n"
    "<xsd:attribute name=\"value\" type=\"String\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"param.get\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"name\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"params\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:choice  minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element ref=\"param\"/>\n"
    "\n"
    "<xsd:element name=\"copy_params\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"from\"  use=\"required\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>Only valid in element job/commands/start_job and job/commands/add_order</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"task\"/>\n"
    "<xsd:enumeration value=\"order\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"include\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"file\"      type=\"File\"/>\n"
    "<xsd:attribute name=\"live_file\" type=\"File\"/>\n"
    "<xsd:attribute name=\"node\" type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"params.get\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"period\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"single_start\"  type=\"Time_of_day\"/>\n"
    "<xsd:attribute name=\"begin\"         type=\"Time_of_day\"/>\n"
    "<xsd:attribute name=\"end\"           type=\"Time_of_day\"/>\n"
    "<xsd:attribute name=\"let_run\"       type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"repeat\"        type=\"Duration\"/>\n"
    "<xsd:attribute name=\"absolute_repeat\" type=\"Duration\"/>\n"
    "<xsd:attribute name=\"when_holiday\"  type=\"When_holiday\"/>\n"
    "\n"
    "<xsd:attribute name=\"start_once\"    type=\"Yes_no\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>Test only for Joacim Zschimmer</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"process_class\"               type=\"process_class\"/>\n"
    "<xsd:element name=\"process_class.remove\"        type=\"process_class.remove\"/>\n"
    "\n"
    "<xsd:element name=\"process_classes\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"process_class\" type=\"process_class\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"ignore\"        type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "<!-- XML-Schema erlaubt keine leeren Schl\xc3" "\xbc" "ssel.\n"
    "<xsd:key name=\"process_class\">\n"
    "<xsd:selector xpath=\"process_class\"/>\n"
    "<xsd:field xpath=\"@name\"/>\n"
    "</xsd:key-->\n"
    "\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"register_remote_scheduler\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"ERROR\" minOccurs=\"0\">\n"
    "<xsd:complexType/>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"version\"           type=\"String\"/>\n"
    "<xsd:attribute name=\"scheduler_id\"      type=\"String\"/>\n"
    "<xsd:attribute name=\"tcp_port\"          type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"udp_port\"          type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"is_cluster_member\" type=\"String\"/>\n"
    "<xsd:attribute name=\"logoff\"            type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"remove_job_chain\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job_chain\"     type=\"Path\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"remove_order\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job_chain\"     type=\"Path\"         use=\"required\"/>\n"
    "<xsd:attribute name=\"order\"         type=\"Order_id\"     use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"run_time\" type=\"run_time\"/>      <!-- F\xc3" "\xbc" "r Order.Run_time.xml = \"<run_time>\" -->\n"
    "\n"
    "\n"
    "<xsd:element name=\"s\" type=\"Show_state\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"schedule\" type=\"run_time\"/>\n"
    "\n"
    "<xsd:element name=\"schedule.remove\" type=\"schedule.remove\"/>\n"
    "\n"
    "<xsd:element name=\"script\">\n"
    "<xsd:complexType mixed=\"true\">\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element ref=\"include\"/>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:attribute name=\"language\"              type=\"Name\"/>\n"
    "\n"
    "<xsd:attribute name=\"use_engine\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"task\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "<xsd:attribute name=\"com_class\"             type=\"String\"/>\n"
    "<xsd:attribute name=\"filename\"              type=\"File\"/>\n"
    "<xsd:attribute name=\"java_class\"            type=\"String\"/>\n"
    "<xsd:attribute name=\"recompile\"             type=\"Yes_no\"/>\n"
    "<!--xsd:attribute name=\"process_class\"         type=\"Path\"    s. eMail von P\xc3" "\xbc" "schel 2007-11-06 12:55 /-->\n"
    "<xsd:attribute name=\"encoding\"              type=\"Code_page_encoding\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"security\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"allowed_host\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"host\" type=\"String\" use=\"required\"/>\n"
    "\n"
    "<xsd:attribute name=\"level\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"none\"/>\n"
    "<xsd:enumeration value=\"signal\"/>\n"
    "<xsd:enumeration value=\"info\"/>\n"
    "<xsd:enumeration value=\"no_add\"/>\n"
    "<xsd:enumeration value=\"all\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"ignore_unknown_hosts\" type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"supervisor.remote_scheduler.configuration.fetch_updated_files\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element name=\"configuration.file\"      type=\"configuration.file\"/>\n"
    "<xsd:element name=\"configuration.directory\" type=\"configuration.directory\"/>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"cluster\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"heart_beat_timeout\"      type=\"xsd:positiveInteger\"/>\n"
    "\n"
    "<xsd:attribute name=\"heart_beat_own_timeout\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:positiveInteger\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"never\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "<xsd:attribute name=\"heart_beat_warn_timeout\" type=\"xsd:positiveInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"scheduler_log.log_categories.reset\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"delay\"     type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"scheduler_log.log_categories.set\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"category\"  type=\"String\"   use=\"required\"/>\n"
    "<xsd:attribute name=\"value\"     type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"scheduler_log.log_categories.show\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"service_request\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"web_service\" type=\"web_service\" minOccurs=\"0\"/>\n"
    "\n"
    "<xsd:element name=\"content\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:any namespace=\"##any\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"url\"               type=\"String\"/>\n"
    "<xsd:attribute name=\"url_path\"          type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_calendar\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"from\"              type=\"xsd:dateTime\"/>\n"
    "<xsd:attribute name=\"before\"            type=\"xsd:dateTime\"/>\n"
    "<xsd:attribute name=\"limit\"             type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"what\"              type=\"What\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_history\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job\"               type=\"Path\"                     use=\"required\"/>\n"
    "<xsd:attribute name=\"id\"                type=\"Task_id\"/>\n"
    "<xsd:attribute name=\"prev\"              type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"next\"              type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"what\"              type=\"What\"/>\n"
    "<xsd:attribute name=\"max_orders\"        type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_job\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job\"               type=\"Path\"                     use=\"required\"/>\n"
    "<xsd:attribute name=\"job_chain\"         type=\"Path\"/>\n"
    "<xsd:attribute name=\"what\"              type=\"What\"/>\n"
    "<xsd:attribute name=\"max_orders\"        type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"max_task_history\"  type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_job_chain\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job_chain\"         type=\"Path\"                     use=\"required\"/>\n"
    "<xsd:attribute name=\"what\"              type=\"What\"/>\n"
    "<xsd:attribute name=\"max_orders\"        type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"max_order_history\" type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_job_chains\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"what\"              type=\"Path\"/>\n"
    "<xsd:attribute name=\"max_orders\"        type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"max_order_history\" type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_jobs\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"what\"              type=\"What\"/>\n"
    "<xsd:attribute name=\"max_orders\"        type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"max_task_history\"  type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_order\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"job_chain\"         type=\"Path\"                     use=\"required\"/>\n"
    "<xsd:attribute name=\"order\"             type=\"Order_id\"/>\n"
    "<xsd:attribute name=\"history_id\"        type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"what\"              type=\"What\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_schedulers\" type=\"Show_state\"/>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_state\" type=\"Show_state\"/>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"Show_state\">\n"
    "<xsd:attribute name=\"what\"                  type=\"String\"/>\n"
    "<xsd:attribute name=\"max_orders\"            type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"max_order_history\"     type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"max_task_history\"      type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"path\"                  type=\"Path\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:element name=\"show_task\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"id\"    type=\"Task_id\"  use=\"required\"/>\n"
    "<xsd:attribute name=\"what\"  type=\"What\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"start_job\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"params\" minOccurs=\"0\"/>\n"
    "<xsd:element name=\"environment\" type=\"environment\" minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"job\"               type=\"Path\"                     use=\"required\"/>\n"
    "<xsd:attribute name=\"name\"              type=\"Name\"/>\n"
    "<xsd:attribute name=\"at\"                type=\"Date_time_with_now_or_period\"/>\n"
    "<xsd:attribute name=\"after\"             type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"web_service\"       type=\"Name\"/>\n"
    "<xsd:attribute name=\"force\"             type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"remote_scheduler.start_remote_task\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"tcp_port\"          type=\"xsd:nonNegativeInteger\"   use=\"required\"/>\n"
    "<xsd:attribute name=\"kind\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"process\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"remote_scheduler.remote_task.close\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"process_id\"        type=\"xsd:long\"   use=\"required\"/>\n"
    "<xsd:attribute name=\"kill\"              type=\"Yes_no\"                   />\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"terminate\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"all_schedulers\" type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"restart\"        type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"timeout\"        type=\"xsd:integer\"/>\n"
    "\n"
    "<xsd:attribute name=\"continue_exclusive_operation\" type=\"Yes_no\"/>\n"
    "<!--xsd:attribute name=\"continue_exclusive_operation\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"non_backup\"/>\n"
    "<xsd:enumeration value=\"this\"/>\n"
    "<xsd:enumeration value=\"any\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\"http://.+\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute-->\n"
    "\n"
    "<xsd:attribute name=\"cluster_member_id\" type=\"String\"/>\n"
    "<xsd:attribute name=\"delete_dead_entry\" type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"get_events\">\n"
    "<xsd:complexType/>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"http_server\">\n"
    "<xsd:complexType >\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element name=\"http.authentication\" type=\"http.authentication\"/>\n"
    "<xsd:element name=\"web_service\"         type=\"web_service\"/>\n"
    "<xsd:element name=\"http_directory\"      type=\"http_directory\"/>\n"
    "</xsd:choice>\n"
    "</xsd:complexType>\n"
    "\n"
    "<!--libxslt xsd:key name=\"web_service\">\n"
    "<xsd:selector xpath=\"web_service\"/>\n"
    "<xsd:field xpath=\"@name\"/>\n"
    "</xsd:key-->\n"
    "\n"
    "<!--libxslt xsd:key name=\"web_service.url_path\">\n"
    "<xsd:selector xpath=\"web_service\"/>\n"
    "<xsd:field xpath=\"@url_path\"/>\n"
    "</xsd:key-->\n"
    "\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<xsd:element name=\"web_services\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>Deprecated. Use http_server</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"web_service\" type=\"web_service\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "\n"
    "<!--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ELEMENT-TYPEN-->\n"
    "\n"
    "<xsd:complexType name=\"check_folders\"/>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"configuration.directory\">\n"
    "<xsd:sequence>\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element name=\"configuration.directory\" type=\"configuration.directory\"/>\n"
    "<xsd:element name=\"configuration.file\"      type=\"configuration.file\"/>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "<xsd:attribute name=\"name\" type=\"String\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"configuration.file\">\n"
    "<!--xsd:sequence>\n"
    "<xsd:element name=\"content\" type=\"content\"/>\n"
    "</xsd:sequence-->\n"
    "<xsd:attribute name=\"name\"              type=\"String\"          use=\"required\"/>\n"
    "<xsd:attribute name=\"last_write_time\"   type=\"xsd:dateTime\"/>\n"
    "<xsd:attribute name=\"md5\"               type=\"Md5\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"environment\">\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"variable\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"name\"  type=\"String\" use=\"required\"/>\n"
    "<xsd:attribute name=\"value\" type=\"String\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"http.authentication\">\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"http.users\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"http.user\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"name\"          type=\"Name\"             use=\"required\"/>\n"
    "<xsd:attribute name=\"password_md5\"  type=\"Md5_checksum\"     use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"scheme\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"basic\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"http_directory\">\n"
    "<xsd:attribute name=\"url_path\"                  type=\"Url_path\"         use=\"required\"/>\n"
    "\n"
    "<xsd:attribute name=\"path\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\".+\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"lock\">\n"
    "<xsd:attribute name=\"name\"                      type=\"Name\"/>\n"
    "<xsd:attribute name=\"max_non_exclusive\"         type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"lock.remove\">\n"
    "<xsd:attribute name=\"lock\"                      type=\"Path\"                     use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"modify_hot_folder\">\n"
    "<xsd:choice>\n"
    "<xsd:element ref=\"job\"/>\n"
    "<xsd:element ref=\"job_chain\"/>\n"
    "<xsd:element ref=\"lock\"/>\n"
    "<xsd:element ref=\"order\"/>\n"
    "<xsd:element ref=\"process_class\"/>\n"
    "<xsd:element ref=\"schedule\"/>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:attribute name=\"folder\" type=\"Path\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"monthdays\">\n"
    "<xsd:sequence maxOccurs=\"unbounded\">\n"
    "<xsd:choice>\n"
    "<xsd:element name=\"day\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"day\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:list>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:positiveInteger\">\n"
    "<xsd:maxInclusive value=\"31\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:list>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"weekday\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"day\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:list itemType=\"Weekday\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "\n"
    "<xsd:attribute name=\"which\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:positiveInteger\">\n"
    "<xsd:maxInclusive value=\"4\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:negativeInteger\">\n"
    "<xsd:minInclusive value=\"-4\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"process_class\">\n"
    "<xsd:attribute name=\"name\"                      type=\"Name\"/>\n"
    "<xsd:attribute name=\"max_processes\"             type=\"xsd:nonNegativeInteger\"/>\n"
    "<xsd:attribute name=\"remote_scheduler\"          type=\"String\"/>\n"
    "\n"
    "<xsd:attribute name=\"spooler_id\"                type=\"Name\"/>\n"
    "<xsd:attribute name=\"replace\"                   type=\"Yes_no\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"process_class.remove\">\n"
    "<xsd:attribute name=\"process_class\"             type=\"Path\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"run_time\">\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "\n"
    "<xsd:element name=\"at\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:attribute name=\"at\" type=\"Loose_date_time\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"date\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "<xsd:attribute name=\"date\" type=\"String\" use=\"required\"/>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"weekdays\" type=\"weekdays\" minOccurs=\"0\">\n"
    "<!--libxslt xsd:key name=\"weekdays\">\n"
    "<xsd:selector xpath=\"day\"/>\n"
    "<xsd:field xpath=\"@day\"/>\n"
    "</xsd:key-->\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"monthdays\" type=\"monthdays\" minOccurs=\"0\">\n"
    "<!--libxslt xsd:key name=\"monthdays\">\n"
    "<xsd:selector xpath=\"day\"/>\n"
    "<xsd:field xpath=\"@day\"/>\n"
    "</xsd:key-->\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"ultimos\" type=\"ultimos\" minOccurs=\"0\">\n"
    "<!--libxslt xsd:key name=\"ultimos\">\n"
    "<xsd:selector xpath=\"day\"/>\n"
    "<xsd:field xpath=\"@day\"/>\n"
    "</xsd:key-->\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:element name=\"month\" minOccurs=\"0\" maxOccurs=\"12\">\n"
    "<xsd:complexType>\n"
    "<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "<xsd:element name=\"weekdays\"  type=\"weekdays\"/>\n"
    "<xsd:element name=\"monthdays\" type=\"monthdays\"/>\n"
    "<xsd:element name=\"ultimos\"   type=\"ultimos\"/>\n"
    "</xsd:choice>\n"
    "\n"
    "<xsd:attribute name=\"month\">\n"
    "<xsd:simpleType>\n"
    "<xsd:list itemType=\"Month_name\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "\n"
    "<xsd:choice>\n"
    "<xsd:element ref=\"holidays\"/>\n"
    "<xsd:element ref=\"holiday\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:choice>\n"
    "</xsd:sequence>\n"
    "\n"
    "\n"
    "<xsd:attribute name=\"schedule\"          type=\"String\"/>             <!-- Nur zum Abruf (\"<schedule.use>\") -->\n"
    "\n"
    "<xsd:attribute name=\"name\"              type=\"Name\"/>               <!-- Nur zur Definition eines benannten <schedule> -->\n"
    "<xsd:attribute name=\"title\"             type=\"String\"/>\n"
    "\n"
    "<xsd:attribute name=\"substitute\"        type=\"Path\"/>               <!-- F\xc3" "\xbc" "r \xc3" "\xbc" "berdeckendes <schedule> -->\n"
    "<xsd:attribute name=\"valid_from\"        type=\"Date_time\"/>\n"
    "<xsd:attribute name=\"valid_to\"          type=\"Date_time\"/>\n"
    "\n"
    "<xsd:attribute name=\"single_start\"      type=\"Time_of_day\"/>\n"
    "<xsd:attribute name=\"begin\"             type=\"Time_of_day\"/>\n"
    "<xsd:attribute name=\"end\"               type=\"Time_of_day\"/>\n"
    "<xsd:attribute name=\"let_run\"           type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"repeat\"            type=\"Duration\"/>\n"
    "<xsd:attribute name=\"when_holiday\"      type=\"When_holiday\"/>\n"
    "<xsd:attribute name=\"once\"              type=\"Yes_no\"/>\n"
    "<xsd:attribute name=\"start_time_function\" type=\"xsd:NMTOKEN\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"schedule.remove\">\n"
    "<xsd:attribute name=\"schedule\"          type=\"Path\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"scheduler_script\">\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"script\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"name\"                      type=\"Name\"/>\n"
    "<xsd:attribute name=\"ordering\"                  type=\"xsd:nonNegativeInteger\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "<xsd:complexType  name=\"ultimos\">\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"day\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"day\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:list>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:nonNegativeInteger\">\n"
    "<xsd:maxInclusive value=\"30\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:list>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"web_service\">\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"params\" minOccurs=\"0\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"name\"                      type=\"Name\"/>\n"
    "<xsd:attribute name=\"url_path\"                  type=\"Url_path\"         use=\"required\"/>\n"
    "<xsd:attribute name=\"debug\"                     type=\"Yes_no\"/>\n"
    "\n"
    "<!-- Diese Attribute und die folgenden Attribute schlie\xc3" "\x9f" "en einander aus -->\n"
    "<xsd:attribute name=\"request_xslt_stylesheet\"   type=\"File\"             />\n"
    "<xsd:attribute name=\"response_xslt_stylesheet\"  type=\"File\"             />\n"
    "<xsd:attribute name=\"forward_xslt_stylesheet\"   type=\"File\"/>\n"
    "\n"
    "<xsd:attribute name=\"job_chain\"                 type=\"Path\"/>\n"
    "<xsd:attribute name=\"timeout\"                   type=\"xsd:positiveInteger\"/>\n"
    "</xsd:complexType>\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"weekdays\">\n"
    "<xsd:sequence>\n"
    "<xsd:element name=\"day\" maxOccurs=\"unbounded\">\n"
    "<xsd:complexType>\n"
    "<xsd:sequence>\n"
    "<xsd:element ref=\"period\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\n"
    "</xsd:sequence>\n"
    "\n"
    "<xsd:attribute name=\"day\" use=\"required\">\n"
    "<xsd:simpleType>\n"
    "<xsd:list itemType=\"Weekday\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:attribute>\n"
    "</xsd:complexType>\n"
    "</xsd:element>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType >\n"
    "\n"
    "\n"
    "\n"
    "<xsd:complexType name=\"Xml_payload\">\n"
    "<xsd:sequence minOccurs=\"0\">\n"
    "<xsd:any processContents=\"skip\"/>\n"
    "</xsd:sequence>\n"
    "</xsd:complexType>\n"
    "\n"
    "<!--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ATTRIBUT-TYPEN-->\n"
    "\n"
    "<xsd:simpleType name=\"Code_page_encoding\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"oem\"/>\n"
    "<xsd:enumeration value=\"cp437\"/>\n"
    "<xsd:enumeration value=\"cp850\"/>\n"
    "<xsd:enumeration value=\"latin1\"/>\n"
    "<xsd:enumeration value=\"none\"/><!-- Nur zum Test -->\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType name=\"Job_chain_node.Action\">\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:enumeration value=\"process\"/>\n"
    "<xsd:enumeration value=\"stop\"/>\n"
    "<xsd:enumeration value=\"next_state\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType name=\"Yes_no\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"yes\"/>\n"
    "<xsd:enumeration value=\"no\"/>\n"
    "<xsd:enumeration value=\"true\"/>\n"
    "<xsd:enumeration value=\"false\"/>\n"
    "<xsd:enumeration value=\"1\"/>\n"
    "<xsd:enumeration value=\"0\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"No\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"no\"/>\n"
    "<xsd:enumeration value=\"false\"/>\n"
    "<xsd:enumeration value=\"0\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Yes_no_never\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Yes_no\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"never\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Md5_checksum\">\n"
    "<xsd:restriction base=\"xsd:string\">\n"
    "<xsd:length value=\"32\" fixed=\"true\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Name\">\n"
    "<!-- Eine engere Beschr\xc3" "\xa4" "nkung w\xc3" "\xa4" "re gut: Buchstabe gefolgt von (Buchstabe, Ziffer, _ und vielleicht -)*  -->\n"
    "<!-- Regul\xc3" "\xa4" "rer Ausdruck wie bei Path -->\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\"[^/]*\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Path\">\n"
    "<!-- Eine Folge von Name. Regul\xc3" "\xa4" "rer Ausdruck wie bei Name -->\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\"/?([^/]+/)*([^/]*)\"/>    <!--  /?  ( Name / )+  Name  -->\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"What\">\n"
    "<xsd:restriction base=\"String\">\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Task_id\">\n"
    "<xsd:restriction base=\"xsd:positiveInteger\"/>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Order_id\">\n"
    "<xsd:restriction base=\"String\"/>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"File\">\n"
    "<xsd:restriction base=\"String\"/>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Date_time\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>\"yyyy-mm-dd HH:MM[:SS]\"</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\"[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}(:[0-9]{2})?\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Loose_date_time\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>\"yyyy-mm-dd HH:MM[:SS]\"</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:restriction base=\"String\">\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Date_time_with_now\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>\"yyyy-mm-dd HH:MM[:SS]\", \"now + HH:MM[:SS]\" or \"now+SECONDS\"</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:restriction base=\"String\">\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Date_time_with_now_or_period\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Date_time_with_now\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"period\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Time_of_day\">\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\"\\d{1,2}:\\d{2}(:\\d\\d)?\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Weekday\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:pattern value=\"[01234567]|(so(nntag)?)|(mo(ntag)?)|(di(enstag)?)|(mi(ttwoch)?)|(do(nnerstag)?)|(fr(eitag)?)|(sa(mstag)?)|(sun(day)?)|(mon(day)?)|(tue(sday)?)|(wed(nesday)?)|(thu(rsday)?)|(fri(day)?)|(sat(urday)?)\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Duration\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:nonNegativeInteger\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "Duration in seconds\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "Duration in format HH:MM[:SS]\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:pattern value=\"(\\d+)|(\\d+:\\d{2}(:\\d\\d)?)\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Duration_or_never\">\n"
    "<xsd:union>\n"
    "<!--L\xc3" "\xa4" "sst libxml2 abst\xc3" "\xbc" "rzen, Zschimmer 2007-08-19 xsd:simpleType>\n"
    "<xsd:restriction base=\"Duration\"/>\n"
    "</xsd:simpleType-->\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:nonNegativeInteger\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "Duration in seconds\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "Duration in format HH:MM[:SS]\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:pattern value=\"(\\d+)|(\\d+:\\d{2}(:\\d\\d)?)\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"never\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Duration_or_percentage\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:nonNegativeInteger\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "Duration in seconds\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation xml:lang=\"de\">\n"
    "Duration in format HH:MM[:SS]\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:pattern value=\"(\\d+)|(\\d+:\\d{2}(:\\d\\d)?)\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:string\">\n"
    "<xsd:pattern value=\"\\d+%\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "\n"
    "<!--libxml2 bricht ab:\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Duration\"/>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:string\">\n"
    "<xsd:pattern value=\"\\d+%\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "-->\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Log_level\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"error\"/>\n"
    "<xsd:enumeration value=\"warn\"/>\n"
    "<xsd:enumeration value=\"info\"/>\n"
    "<xsd:enumeration value=\"debug\"/>\n"
    "<xsd:enumeration value=\"debug1\"/>\n"
    "<xsd:enumeration value=\"debug2\"/>\n"
    "<xsd:enumeration value=\"debug3\"/>\n"
    "<xsd:enumeration value=\"debug4\"/>\n"
    "<xsd:enumeration value=\"debug5\"/>\n"
    "<xsd:enumeration value=\"debug6\"/>\n"
    "<xsd:enumeration value=\"debug7\"/>\n"
    "<xsd:enumeration value=\"debug8\"/>\n"
    "<xsd:enumeration value=\"debug9\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Md5\">\n"
    "<xsd:restriction base=\"xsd:string\">\n"
    "<xsd:pattern value=\"[0-9a-fA-F]{32}\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Month_name\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"january\"/>\n"
    "<xsd:enumeration value=\"february\"/>\n"
    "<xsd:enumeration value=\"march\"/>\n"
    "<xsd:enumeration value=\"april\"/>\n"
    "<xsd:enumeration value=\"may\"/>\n"
    "<xsd:enumeration value=\"june\"/>\n"
    "<xsd:enumeration value=\"july\"/>\n"
    "<xsd:enumeration value=\"august\"/>\n"
    "<xsd:enumeration value=\"september\"/>\n"
    "<xsd:enumeration value=\"october\"/>\n"
    "<xsd:enumeration value=\"november\"/>\n"
    "<xsd:enumeration value=\"december\"/>\n"
    "<xsd:enumeration value=\"1\"/>\n"
    "<xsd:enumeration value=\"2\"/>\n"
    "<xsd:enumeration value=\"3\"/>\n"
    "<xsd:enumeration value=\"4\"/>\n"
    "<xsd:enumeration value=\"5\"/>\n"
    "<xsd:enumeration value=\"6\"/>\n"
    "<xsd:enumeration value=\"7\"/>\n"
    "<xsd:enumeration value=\"8\"/>\n"
    "<xsd:enumeration value=\"9\"/>\n"
    "<xsd:enumeration value=\"10\"/>\n"
    "<xsd:enumeration value=\"11\"/>\n"
    "<xsd:enumeration value=\"12\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType name=\"Non_empty_string\">\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\".+\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "<xsd:simpleType name=\"Positive_duration\">\n"
    "<xsd:restriction base=\"Duration\">\n"
    "<xsd:pattern value=\".*[123456789].*\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Url_path\">\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:pattern value=\"/.*\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"String\">\n"
    "<xsd:annotation>\n"
    "<xsd:documentation>\n"
    "Only characters out of ISO-8859-1 can be used.\n"
    "</xsd:documentation>\n"
    "</xsd:annotation>\n"
    "<xsd:restriction base=\"xsd:string\">\n"
    "<xsd:pattern value=\"[\\r\\n\\t&#x20;-&#x7e;&#xa0;-&#xff;]*\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Process_priority\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Unix_process_priority\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Windows_process_priority_class\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Unix_process_priority\">\n"
    "<xsd:restriction base=\"xsd:integer\">\n"
    "<xsd:minInclusive value=\"-20\"/>\n"
    "<xsd:maxInclusive value=\"+20\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Windows_process_priority_class\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"idle\"/>\n"
    "<xsd:enumeration value=\"below_normal\"/>\n"
    "<xsd:enumeration value=\"normal\"/>\n"
    "<xsd:enumeration value=\"above_normal\"/>\n"
    "<xsd:enumeration value=\"high\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Unix_signal\">\n"
    "<xsd:union>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"Unix_signal_name\"/>\n"
    "</xsd:simpleType>\n"
    "<xsd:simpleType>\n"
    "<xsd:restriction base=\"xsd:positiveInteger\"/>\n"
    "</xsd:simpleType>\n"
    "</xsd:union>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"Unix_signal_name\">\n"
    "<xsd:restriction base=\"xsd:NMTOKEN\">\n"
    "<xsd:enumeration value=\"SIGHUP\"/>\n"
    "<xsd:enumeration value=\"SIGINT\"/>\n"
    "<xsd:enumeration value=\"SIGQUIT\"/>\n"
    "<xsd:enumeration value=\"SIGILL\"/>\n"
    "<xsd:enumeration value=\"SIGTRAP\"/>\n"
    "<xsd:enumeration value=\"SIGABRT\"/>\n"
    "<xsd:enumeration value=\"SIGIOT\"/>\n"
    "<xsd:enumeration value=\"SIGBUS\"/>\n"
    "<xsd:enumeration value=\"SIGFPE\"/>\n"
    "<xsd:enumeration value=\"SIGKILL\"/>\n"
    "<xsd:enumeration value=\"SIGUSR1\"/>\n"
    "<xsd:enumeration value=\"SIGSEGV\"/>\n"
    "<xsd:enumeration value=\"SIGUSR2\"/>\n"
    "<xsd:enumeration value=\"SIGPIPE\"/>\n"
    "<xsd:enumeration value=\"SIGALRM\"/>\n"
    "<xsd:enumeration value=\"SIGTERM\"/>\n"
    "<xsd:enumeration value=\"SIGSTKFLT\"/>\n"
    "<xsd:enumeration value=\"SIGCHLD\"/>\n"
    "<xsd:enumeration value=\"SIGCONT\"/>\n"
    "<xsd:enumeration value=\"SIGSTOP\"/>\n"
    "<xsd:enumeration value=\"SIGTSTP\"/>\n"
    "<xsd:enumeration value=\"SIGTTIN\"/>\n"
    "<xsd:enumeration value=\"SIGTTOU\"/>\n"
    "<xsd:enumeration value=\"SIGURG\"/>\n"
    "<xsd:enumeration value=\"SIGXCPU\"/>\n"
    "<xsd:enumeration value=\"SIGXFSZ\"/>\n"
    "<xsd:enumeration value=\"SIGVTALRM\"/>\n"
    "<xsd:enumeration value=\"SIGPROF\"/>\n"
    "<xsd:enumeration value=\"SIGWINCH\"/>\n"
    "<xsd:enumeration value=\"SIGPOLL\"/>\n"
    "<xsd:enumeration value=\"SIGIO\"/>\n"
    "<xsd:enumeration value=\"SIGPWR\"/>\n"
    "<xsd:enumeration value=\"SIGSYS\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "\n"
    "<xsd:simpleType name=\"When_holiday\">\n"
    "<xsd:restriction base=\"String\">\n"
    "<xsd:enumeration value=\"suppress\"/>\n"
    "<xsd:enumeration value=\"ignore_holiday\"/>\n"
    "<xsd:enumeration value=\"previous_non_holiday\"/>\n"
    "<xsd:enumeration value=\"next_non_holiday\"/>\n"
    "</xsd:restriction>\n"
    "</xsd:simpleType>\n"
    "\n"
    "</xsd:schema>\n"
    "";

const char file_doc_en_log_categories_xml[] = 
    "\xef" "\xbb" "\xbf" "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
    "<?xml-stylesheet href=\"scheduler.xsl\" type=\"text/xsl\"?>\n"
    "\n"
    "<!--$Id: spooler_embedded_files.cxx 6067 2010-03-23 11:46:42Z ss $-->\n"
    "\n"
    "<log_categories \n"
    "\x09" "\x09" "title=\"Log Categories\" \n"
    "\x09" "\x09" "base_dir=\"\" \n"
    "\x09" "\x09" "author=\"$Author: ss $\" \n"
    "date     = \"$Date: 2010-03-23 12:46:42 +0100 (Di, 23 Mär 2010) $\"\n"
    ">\n"
    "\n"
    "\x09" "\x09" "<scheduler_keyword keyword=\"Log Categories\"/>\n"
    "<!--<scheduler_keyword keyword=\"Log-Kategorien\"/>-->\n"
    "\n"
    "\x09" "\x09" "<scheduler_keyword keyword=\"Categories for Log Files\"/>\n"
    "<!--<scheduler_keyword keyword=\"Kategorien f\xc3" "\xbc" "rs Log\"/>-->\n"
    "\n"
    "\x09" "<log_category name=\"all\" title=\"All categories (with exception of explicit categories)\">\n"
    "\x09" "\x09" "<!--<log_category name=\"all\"            title=\"Alle Kategorien (au\xc3" "\x9f" "er nur explizite)\">-->\n"
    "\x09" "</log_category>\n"
    "\n"
    "\x09" "<!--\n"
    "<log_category name=\"async\"          title=\"Asynchrone Aufrufe (f\xc3" "\xbc" "r den nebenl\xc3" "\xa4" "ufigen Betrieb der Scheduler-Tasks)\">\n"
    "<log_category name=\"continue\"       title=\"Fortsetzen einer asynchronen Operation\"/>\n"
    "</log_category>\n"
    "-->\n"
    "\n"
    "\x09" "\x09" "<log_category name=\"com\" title=\"COM-Operations\">\n"
    "\x09" "\x09" "\x09" "<log_category name=\"invoke\" title=\"Calling a COM object method\"/>\n"
    "<!--<log_category name=\"com\"            title=\"COM-Operationen\">\n"
    "<log_category name=\"invoke\"         title=\"Aufruf einer Methode eines COM-Objekts\"/>-->\n"
    "\x09" "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"env\"            title=\"Environment variables\">\n"
    "<!--<log_category name=\"env\"            title=\"Umgebungsvariablen\">-->\n"
    "</log_category>\n"
    "\n"
    "\x09" "\x09" "<log_category name=\"exception\" title=\"Particular error codes\">\n"
    "\x09" "\x09" "\x09" "<log_category name=\"*\"              default=\"yes\"\x09" "\x09" "title=\"All error codes\"/>\n"
    "\x09" "\x09" "\x09" "<log_category name=\"D310\"           mode=\"explicit\"\x09" "\x09" "title=\"End of file\"/>\n"
    "\x09" "\x09" "\x09" "<log_category name=\"D311\"           mode=\"explicit\"\x09" "\x09" "title=\"Expression not found\"/>\n"
    "<!--<log_category name=\"*\"              default=\"yes\"   title=\"Alle Fehlercodes\"/>\n"
    "<log_category name=\"D310\"           mode=\"explicit\" title=\"Dateiende\"/>\n"
    "<log_category name=\"D311\"           mode=\"explicit\" title=\"Satz nicht gefunden\"/>-->\n"
    "\x09" "\x09" "</log_category>\n"
    "\n"
    "\x09" "<log_category name=\"factory\" title=\"DocumentFactory\">\n"
    "<log_category name=\"parameter\" />\n"
    "\x09" "\x09" "<log_category name=\"processor\" title=\"Factory Processor (hostole.dll)\"/>\n"
    "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"file\"           title=\"\">\n"
    "<log_category name=\"directory\"/>\n"
    "<log_category name=\"mmap\"       title=\"mmap()\"/>\n"
    "</log_category>\n"
    "\n"
    "\x09" "<log_category name=\"hostole\" title=\"HostOLE calls (with exception of the factory processor)\">\n"
    "\x09" "\x09" "<!--<log_category name=\"hostole\"        title=\"Hostole-Aufrufe (au\xc3" "\x9f" "er Factory Processor)\">-->\n"
    "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"ini\"            title=\"Windows call GetPrivateProfile()\">\n"
    "<!--<log_category name=\"ini\"            title=\"Windows-Aufruf GetPrivateProfile()\">-->\n"
    "\x09" "\x09" "\x09" "<description>\n"
    "\x09" "\x09" "\x09" "\x09" "<p>\n"
    "Read the .ini file: <code>GetPrivateProfile()</code>.\n"
    "<!--.ini-Datei lesen: <code>GetPrivateProfile()</code>.-->\n"
    "\x09" "\x09" "\x09" "\x09" "</p>\n"
    "\x09" "\x09" "\x09" "</description>\n"
    "\x09" "\x09" "</log_category>\n"
    "\n"
    "\x09" "\x09" "<log_category name=\"java\" title=\"Java\">\n"
    "\x09" "\x09" "</log_category>\n"
    "\n"
    "\x09" "\x09" "<log_category name=\"jdbc\" title=\"JDBC Calls\">\n"
    "<!--<log_category name=\"jdbc\"           title=\"JDBC-Aufrufe\">-->\n"
    "\x09" "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"mail\"           >\n"
    "</log_category>\n"
    "\n"
    "\x09" "\x09" "<log_category name=\"mutex\"          mode=\"explicit\" title=\"Mutual exclusion locks, blocking for thread serialisation\">\n"
    "<!--<log_category name=\"mutex\"          mode=\"explicit\" title=\"Mutual exclusion locks, Sperren zur Serialisierung von Threads\">-->\n"
    "\x09" "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"object_server\" title=\"Job Scheduler interface for tasks running in their own processes\">\n"
    "<log_category name=\"call\" title=\"Method Call\"/>\n"
    "<log_category name=\"continue\"       />\n"
    "<log_category name=\"push\" title=\"Stack-Operation for nested method calls\"/>\n"
    "<log_category name=\"wait\"           />\n"
    "<log_category name=\"Invoke\" title=\"COM operation\"/>\n"
    "<log_category name=\"QueryInterface\" title=\"COM operation\"/>\n"
    "\x09" "\x09" "<!--<log_category name=\"object_server\"      title=\"Schnittstelle des Schedulers zu den in eigenen Prozessen laufenden Tasks\">\n"
    "<log_category name=\"call\"           title=\"Aufruf einer Methode\"/>\n"
    "<log_category name=\"push\"           title=\"Stack-Operation bei verschachteltem Aufruf einer Methode\"/>\n"
    "<log_category name=\"Invoke\"         title=\"COM-Operation\"/>\n"
    "<log_category name=\"QueryInterface\" title=\"COM-Operation\"/>-->\n"
    "</log_category>\n"
    "\n"
    "\x09" "<log_category name=\"odbc\" title=\"ODBC calls\">\n"
    "\x09" "\x09" "<!--<log_category name=\"odbc\"           title=\"ODBC-Aufrufe\">-->\n"
    "\x09" "</log_category>\n"
    "\n"
    "\x09" "<log_category name=\"rtf\" title=\"RTF Processor\">\n"
    "\x09" "\x09" "<log_category name=\"map_next_line\" title=\"Positions of script line numbers found in RTF documents\"/>\n"
    "\x09" "\x09" "<log_category name=\"merge\" title=\"Merge different templates\"/>\n"
    "\x09" "\x09" "<log_category name=\"learn\" title=\"Learned (unknown) RTF codes\"/>\n"
    "\x09" "\x09" "<!--<log_category name=\"rtf\"                title=\"RTF-Prozessor\">\n"
    "<log_category name=\"map_next_line\"  title=\"Zuordnung der Stellen im RTF-Dokument den Zeilennummern des extrahierten Vorlagenskripts\"/>\n"
    "<log_category name=\"merge\"          title=\"Mischen verschiedener Vorlagen\"/>\n"
    "<log_category name=\"learn\"          title=\"Hinzugelernte (unbekannte) RTF-Codes\"/>-->\n"
    "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"scheduler\"   mode=\"implicit\"  title=\"Job Scheduler\">\n"
    "<log_category name=\"call\"          mode=\"implicit\"   title=\"Start and end call of a job method, e.g. spooler_process()\"/>\n"
    "<log_category name=\"cluster\"                         title=\"Cluster operation\"/>\n"
    "<log_category name=\"directory\"                       title=\"Open a directory\"/>\n"
    "<log_category name=\"file_order\"                      title=\"&lt;file_order_source>\"/>\n"
    "<log_category name=\"http\"                            title=\"HTTP server\"/>\n"
    "<log_category name=\"log\"                             title=\"Access to protocol files\"/>\n"
    "<!--<log_category name=\"loop\"           mode=\"explicit\"  title=\"A Job Scheduler micro-cycle\"/>--><!-- Auskommentiert nach Telefonat JZ -->\n"
    "<log_category name=\"order\"          mode=\"implicit\"  title=\"Operations on orders (temporary payload setting)\"/>\n"
    "<log_category name=\"service\"        mode=\"implicit\"  title=\"Windows service controller\"/>\n"
    "<log_category name=\"signal\"    />\n"
    "<log_category name=\"wait\"                            title=\"The Job Scheduler enters the waiting state\"/>\n"
    "<log_category name=\"xml\"                             title=\"XML/DOM operations\"/>\n"
    "<log_category name=\"nothing_done\"                    title=\"When a job is idle\"/>\n"
    "<!--<log_category name=\"scheduler\"     mode=\"implicit\"  title=\"Scheduler\">\n"
    "<log_category name=\"call\"           mode=\"implicit\"  title=\"Beginn und Ende des Aufrufs einer Jobmethode, z.B. spooler_process()\"/>\n"
    "<log_category name=\"cluster\"                         title=\"Cluster-Betrieb\"/>\n"
    "<log_category name=\"directory\"                       title=\"\xc3" "\x96" "ffnen eines Dateiverzeichnisses\"/>\n"
    "<log_category name=\"file_order\"                      title=\"&lt;file_order_source>\"/>\n"
    "<log_category name=\"http\"                            title=\"HTTP-Server\"/>\n"
    "<log_category name=\"log\"                             title=\"Zugriffe auf die Protokolldateien\"/>\n"
    "<log_category name=\"loop\"        local_default=\"off\" title=\"Mikrozyklus des Schedulers\"/>\n"
    "<log_category name=\"order\"          mode=\"implicit\"  title=\"Operation auf Auftr\xc3" "\xa4" "ge (zurzeit Setzen der Payload)\"/>\n"
    "<log_category name=\"service\"        mode=\"implicit\"  title=\"Windows-Dienstesteuerung\"/>\n"
    "<log_category name=\"signal\"    />\n"
    "<log_category name=\"wait\"                            title=\"Wenn der Scheduler in den Wartezustand geht\"/>\n"
    "<log_category name=\"xml\"                             title=\"XML/DOM-Operationen\"/>\n"
    "<log_category name=\"nothing_done\"                    title=\"Wenn ein Job im Leerlauf ist\"/>-->\n"
    "</log_category>\n"
    "\n"
    "<log_category name=\"socket\"     title=\"Socket operations (network)\">\n"
    "<log_category name=\"accept\"     title=\"System call accept(): accept TCP connections\"/>\n"
    "<log_category name=\"close\"      title=\"System call close(): close socket\"/>\n"
    "<log_category name=\"connect\"    title=\"System call connect(): establish TCP connection\"/>\n"
    "<log_category name=\"listen\"     title=\"System call listen(): waiting for TCP connection request (listening)\"/>\n"
    "<log_category name=\"send\"       title=\"System call send(): send file\"/>\n"
    "<log_category name=\"recv\"       title=\"System call send(): receive file\"/>\n"
    "<log_category name=\"select\"     title=\"System call select(): waiting for TCP result\"/>\n"
    "<log_category name=\"setsockopt\" title=\"System call setsockopt()\"/>\n"
    "<log_category name=\"shutdown\"   title=\"System call shutdown(): end connection\"/>\n"
    "<log_category name=\"data\"       mode=\"explicit\" title=\"Data from recv() and send()\"/>\n"
    "<!--<log_category name=\"socket\"         title=\"Socket-Operationen (Netzwerk)\">\n"
    "<log_category name=\"accept\"     title=\"Systemaufruf accept(): TCP-Verbindung annehmen\"/>\n"
    "<log_category name=\"close\"      title=\"Systemaufruf close(): Socket schlie\xc3" "\x9f" "en\"/>\n"
    "<log_category name=\"connect\"    title=\"Systemaufruf connect(): TCP-Verbindung aufbauen\"/>\n"
    "<log_category name=\"listen\"     title=\"Systemaufruf listen(): TCP-Verbindungsaufforderung erwarten\"/>\n"
    "<log_category name=\"send\"       title=\"Systemaufruf send(): Daten senden\"/>\n"
    "<log_category name=\"recv\"       title=\"Systemaufruf send(): Daten empfangen\"/>\n"
    "<log_category name=\"select\"     title=\"Systemaufruf select(): TCP-Ereignis abwarten\"/>\n"
    "<log_category name=\"setsockopt\" title=\"Systemaufruf setsockopt()\"/>\n"
    "<log_category name=\"shutdown\"   title=\"Systemaufruf shutdown(): Verbindung beenden\"/>\n"
    "<log_category name=\"data\"       mode=\"explicit\" title=\"Daten von recv() und send()\"/>-->\n"
    "</log_category>\n"
    "\n"
    "<log_category name=\"spidermonkey\"   title=\"The Spidermonkey JavaScript implementation\">\n"
    "<log_category name=\"callback\"       mode=\"explicit\" title=\"Spidermonkey call backs\"/>\n"
    "<log_category name=\"idispatch\"      mode=\"explicit\" title=\"COM object management\"/>\n"
    "<!--<log_category name=\"spidermonkey\"   title=\"JavaScript-Implementierung Spidermonkey\">\n"
    "<log_category name=\"callback\"       mode=\"explicit\" title=\"R\xc3" "\xbc" "ckrufe von Spidermonkey\"/>\n"
    "<log_category name=\"idispatch\"      mode=\"explicit\" title=\"Verwaltung der COM-Objekte\"/>-->\n"
    "</log_category>\n"
    "\n"
    "\x09" "<log_category name=\"sossql\" title=\"SQL-Processor (file type sossql)\">\n"
    "\x09" "\x09" "<!--<log_category name=\"sossql\"         title=\"SQL-Prozessor (Dateityp sossql)\">-->\n"
    "\x09" "\x09" "<log_category name=\"get_key\" title=\"Operation get_key()\"/>\n"
    "\x09" "</log_category>\n"
    "\n"
    "<log_category name=\"windows\"        title=\"Betriebssystem Microsoft Windows\">\n"
    "<!--<log_category name=\"windows\"        title=\"Microsoft Windows operating system\">-->\n"
    "<log_category name=\"PeekMessage\"   title=\"Aufruf PeekMessage()\"/>\n"
    "<!--<log_category name=\"PeekMessage\"   title=\"Call PeekMessage()\"/>-->\n"
    "</log_category>\n"
    "\n"
    "\n"
    "\x09" "<description>\n"
    "\x09" "\x09" "<p>\n"
    "Many of the entries made in the log file (<code>scheduler.log</code>) are categorised.\n"
    "These categories are used to regulate whether or not an entry is made in a log file.\n"
    "<!--Viele Ausgaben in die Logdatei (<code>scheduler.log</code>) sind einer Kategorie zugeordnet, \n"
    "mit der die Ausgaben an- oder ausgeschaltet werden k\xc3" "\xb6" "nnen.-->\n"
    "\x09" "\x09" "</p>\n"
    "\x09" "\x09" "<p>\n"
    "A log category is specified in front of the file name,\n"
    "with a \">\" symbol inserted between the category and the file name.\n"
    "Multiple categories are separated by an empty space. \n"
    "For example (in an .ini file):\n"
    "<code>log = scheduler.* socket.* >c:/tmp/scheduler.log</code>.\n"
    "<!--Die Log-Kategorien geben Sie vor dem Dateinamen an, \n"
    "wobei dem Dateinamen ein Gr\xc3" "\xb6" "\xc3" "\x9f" "erzeichen (>) vorangestellt sein muss.\n"
    "Mehrere Kategorien trennen Sie mit einem Zwischenraum. Beispiel (in einer .ini-Datei):\n"
    "<code>log = scheduler.* socket.* >c:/tmp/scheduler.log</code>.-->\n"
    "\x09" "\x09" "</p>\n"
    "\x09" "\x09" "<p>\n"
    "The special category <code>all</code> selects all categories \n"
    "other than those which must be explicitly selected.\n"
    "<!--Die besondere Kategorie <code>all</code> w\xc3" "\xa4" "hlt alle Kategorien aus, \n"
    "au\xc3" "\x9f" "er die, die explizit angegeben werden m\xc3" "\xbc" "ssen.-->\n"
    "\x09" "\x09" "</p>\n"
    "\x09" "\x09" "<p>\n"
    "Log file categories are organised in hierarchies.\n"
    "Categories can be selected together with their subcategories \n"
    "by appending an asterisk (\"<code>.*</code>\") to the category name thus:\n"
    "<code>scheduler.*</code>.\n"
    "<!--Die Kategorien sind hierarchich organisiert.\n"
    "Sie k\xc3" "\xb6" "nnen eine Kategorie mit all deren Unterkategorien ausw\xc3" "\xa4" "hlen, \n"
    "indem Sie dem Namen ein \"<code>.*</code>\" anh\xc3" "\xa4" "ngen. \n"
    "Beispiel: <code>scheduler.*</code>.-->\n"
    "\x09" "\x09" "</p>\n"
    "<p>\n"
    "See also the commands:\n"
    "<!--See also the commands:-->\n"
    "</p>\n"
    "<ul>\n"
    "<li>\n"
    "<scheduler_element name=\"scheduler_log.log_categories.show\" />\n"
    "</li>\n"
    "<li>\n"
    "<scheduler_element name=\"scheduler_log.log_categories.set\" />\n"
    "</li>\n"
    "<li>\n"
    "<scheduler_element name=\"scheduler_log.log_categories.reset\" />\n"
    "</li>\n"
    "</ul>\n"
    "\x09" "</description>\n"
    "\x09" "\n"
    "</log_categories>\n"
    "";


using namespace zschimmer;

namespace sos {
namespace scheduler {

static const Embedded_file embedded_files_array[] = 
{
    { "scheduler.xsd", file_scheduler_xsd, sizeof file_scheduler_xsd - 1, 1269338147 },
    { "doc.en/log_categories.xml", file_doc_en_log_categories_xml, sizeof file_doc_en_log_categories_xml - 1, 1269338144 },
    { NULL, NULL, 0 }
};

extern const Embedded_files embedded_files = { embedded_files_array };

} //namespace scheduler
} //namespace sos
