/********************************************************* begin of preamble
**
** Copyright (C) 2003-2009 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: java_odl.h 3546 2005-04-03 08:30:29Z jz $


/*  Ersatz fr java.odl fr Systeme ohne COM. 
    2004 Zschimmer GmbH
*/


#ifndef __ZSCHIMMER_JAVA_ODL_H
#define __ZSCHIMMER_JAVA_ODL_H

#include "zschimmer.h"


#ifdef Z_WINDOWS

#   if defined _DEBUG
#       import "debug/java.tlb"   rename_namespace("odl") raw_interfaces_only named_guids
#    else
#       import "release/java.tlb" rename_namespace("odl") raw_interfaces_only named_guids
#   endif

#else

#   include "com_server.h"


namespace odl 
{

//extern const LIBID LIBID_zschimmer_java;
extern const IID   IID_Ihas_java_class_name;

//-----------------------------------------------------------------------------Ihas_java_class_name

struct Ihas_java_class_name : IUnknown
{
    DEFINE_UUIDOF( Ihas_java_class_name )

  //Z_DEFINE_GETIDSOFNAMES_AND_INVOKE

    virtual HRESULT     get_Java_class_name             ( BSTR* result ) = 0;
    virtual char*     const_java_class_name             () = 0;
};

//------------------------------------------------------------------------------Has_java_class_name
/*

struct Has_java_class_name : Ihas_java_class_name
{
    STDMETHODIMP            get_java_class_name         ( BSTR* result )                            { return string_to_bstr( const_java_class_name(), result ); }
};

*/
//-------------------------------------------------------------------------------------------------

} //namespace odl

#endif
#endif
